/***************************************************************
 *
 * include/dma.h
 * Header for DMA routines/structures/stuff
 *
 * See LICENSE file included with this source for copyright
 * information.
 *
 ***************************************************************/

#ifndef ____DMA_H_
#define ____DMA_H_

// Some transfer modes.
#define DMA_TRANSFER_MODE_DEMAND  0x00
#define DMA_TRANSFER_MODE_SINGLE  0x40
#define DMA_TRANSFER_MODE_BLOCK   0x80
#define DMA_TRANSFER_MODE_CASCADE 0xC0

#define DMA_TRANSFER_INC 0x00
#define DMA_TRANSFER_DEC 0x20

#define DMA_TRANSFER_AUTOINIT 0x10

#define DMA_TRANSFER_TYPE_TEST 0x00
#define DMA_TRANSFER_TYPE_2MEM 0x04
#define DMA_TRANSFER_TYPE_2DEV 0x08

// These are here just for good measure.
#define DMA_TRANSFER_CHANNEL0 0x00
#define DMA_TRANSFER_CHANNEL1 0x01
#define DMA_TRANSFER_CHANNEL2 0x02
#define DMA_TRANSFER_CHANNEL3 0x03
#define DMA_TRANSFER_CHANNEL4 0x00
#define DMA_TRANSFER_CHANNEL5 0x01
#define DMA_TRANSFER_CHANNEL6 0x02
#define DMA_TRANSFER_CHANNEL7 0x03

/* dma.c */
void DmaMaskChannel(unsigned int);
void DmaUnmaskChannel(unsigned int);
BOOL DmaConfigureChannelPointers(unsigned int, uint32_t);
BOOL DmaConfigureChannelMode(unsigned int, uint8_t);
void *DmaCreateChannel(unsigned int, uint32_t);
void DmaDestroyChannel(unsigned int);
void DmaInit(void);

#endif
