/****************************************************************
 *
 * kernel/arch/i386/include/cpuspec.h
 * CPU-specfic definitions for i386 architecture
 *
 * See LICENSE file included with this source for copyright
 * information.
 *
 ***************************************************************/

#ifndef __I386_CPUSPEC_H_
#define __I386_CPUSPEC_H_

struct regs
{
        unsigned int ds, es, fs, gs;
        unsigned int edi, esi, ebp, esp, ebx, edx, ecx, eax;
        unsigned int int_no, err_code;
        char *eip;
        unsigned int cs, eflags;

        /* Privilege escalation only after this point */
        unsigned int useresp, ss;

        /* V86 mode only after this point */
        unsigned int ves, vds, vfs, vgs;
};

struct tss
{
        unsigned int backlink;
        unsigned int esp0, ss0;
        unsigned int esp1, ss1;
        unsigned int esp2, ss2;
        unsigned int cr3; /* Page table thingy */
        unsigned int eip, eflags;
        unsigned int eax, ecx, edx, ebx;
        unsigned int esp, ebp, esi, edi;
        unsigned int es, cs, ss, ds, fs, gs;
        unsigned int ldt;
        unsigned short t;
	unsigned short iomap;

} __attribute__((__packed__));

#endif /* !__I386_CPUSPEC_H_ */

