/***************************************************************
 *
 * arch/i386/include/gidt.h
 * GDT/IDT structs for AWOS
 *
 * See LICENSE file included with this source for copyright
 * information.
 *
 ***************************************************************/

#ifndef ___I386_GIDT_H_
#define ___I386_GIDT_H_

struct gidt_ptr {
	uint16_t len;
	uint32_t loc;
} __attribute__ ((packed));

struct gidt_gate_entry {
	uint16_t base_low;
	uint16_t segment;
	uint16_t attribs;
	uint16_t base_high;
} __attribute__ ((packed));

struct gidt_block_entry {
	uint16_t limit_low;
	uint16_t base_low;
	uint8_t base_mid;
	uint16_t attribs;
	uint8_t base_high;
} __attribute__ ((packed));

#define GDT_PRESENT 0x8000
#define GDT_DPL0 0x0000
#define GDT_DPL1 0x2000
#define GDT_DPL2 0x4000
#define GDT_DPL3 0x6000
#define GDT_GRAN 0x0080
#define GDT_BIG 0x0040
#define GDT_CODE 0x1800
#    define GDT_CODE_CONF 0x0400
#    define GDT_CODE_READ 0x0200
#define GDT_DATA 0x1000
#    define GDT_DATA_EXPDN 0x0400
#    define GDT_DATA_WRITE 0x0200
#define GDT_TSS32 0x0900
#    define GDT_TSS_BUSY 0x0200
#define GDT_LDT 0x0200

#define IDT_PRESENT 0x8000
#define IDT_DPL0 0x0000
#define IDT_DPL1 0x2000
#define IDT_DPL2 0x4000
#define IDT_DPL3 0x6000
#define IDT_CALL 0x0C00
#define IDT_INT 0x0E00
#define IDT_TRAP 0x0F00

#endif /* !___I386_GIDT_H_ */

