/****************************************************************
 * 
 * arch/i386/mp.h
 * x86 multiprocessor defines (based on Intel MP 1.4 standard)
 * 
 * See LICENSE file included with this source for copyright
 * information.
 * 
 ****************************************************************/

#include <stdint.h>

struct MpConfigTable
{
	uint32_t signature;
	uint16_t length;
	uint8_t revision;
	uint8_t checksum;
	uint64_t oem_id;
	uint8_t product_id[12];
	uint32_t oem_table;
	uint16_t oem_table_size;
	uint16_t entry_count;
	uint32_t lapic_addr;
	uint16_t ext_length;
	uint8_t ext_checksum;
};

struct MpFloating
{
	uint32_t signature;
	struct MpConfigTable *config;
	uint8_t length;
	uint8_t revision;
	uint8_t checksum;
	uint8_t feature[5];
};
