/***************************************************************
 *
 * drivers/comm/uart.h
 * UART defines for AWOS
 *
 * See LICENSE file included with this source for copyright
 * information.
 *
 ***************************************************************/

#ifndef ___COMM_UART_H_
#define ___COMM_UART_H_

#include <stdint.h>

char SerDetectUart(int16_t);
void SerSetUartParams(int16_t, int16_t, uint8_t);
void SerSendChar(int16_t, char);

#define SER_REG_DATA		0x0
#define SER_REG_LINECTL		0x3
#define SER_REG_MODEMCTL	0x4
#define SER_REG_LINESTAT	0x5
#define SER_REG_MODEMSTAT	0x6
#define SER_REG_SCRATCH		0x7

#define SER_LSR_DR	0x01
#define SER_LSR_OE	0x02
#define SER_LSR_PE	0x04
#define SER_LSR_FE	0x08
#define SER_LSR_BI	0x10
#define	SER_LSR_THRE	0x20
#define SER_LSR_TEMT	0x40
#define SER_LSR_FIFOE	0x80

#define SER_BPS_50	0x900
#define SER_BPS_75	0x600
#define SER_BPS_110	0x417
#define SER_BPS_150	0x300
#define SER_BPS_300	0x180
#define SER_BPS_600	0x0C0
#define SER_BPS_1200	0x060
#define SER_BPS_1800	0x040
#define SER_BPS_2400	0x030
#define SER_BPS_3600	0x020
#define SER_BPS_4800	0x018
#define SER_BPS_7200	0x010
#define SER_BPS_9600	0x00C
#define SER_BPS_19200	0x006
#define SER_BPS_38400	0x003
#define SER_BPS_57600	0x002
#define SER_BPS_115200	0x001

#define SER_WORD_5	0x0
#define SER_WORD_6	0x1
#define SER_WORD_7	0x2
#define SER_WORD_8	0x3

#define SER_PAR_NO	0x00
#define SER_PAR_ODD	0x08
#define SER_PAR_EVEN	0x18
#define SER_PAR_MARK	0x28
#define SER_PAR_SPACE	0x38

#define SER_STOP_1	0x0
#define SER_STOP_2	0x1

#define SER_FLAGS_8N1	(SER_WORD_8 | SER_PAR_NO | SER_STOP_1)

#endif	/* !___COMM_UART_H_ */

