/****************************************************************

driver/fs/ramfs.c
Simple RAM filesystem

See LICENSE file included with this source for copyright
information.

****************************************************************/

#include <kernel.h>
#include <cons.h>
#include <input.h>
#include <kalloc.h>
#include <sys/types.h>
#include <string.h>
#include <fs.h>
#include <stdlib.h>

FS_MAKEDRV_STD(
	ramfs_def,
	
	ramfs_fs_getdir,
	ramfs_fs_getfirstent,
	ramfs_fs_getprevent,
	ramfs_fs_getnextent
);

void ramfs_init(void)
{
	FsAddFileSystem(FS_MAGIC_RAMFS, &ramfs_def);
};

AW_FILE *ramfs_fopen(struct fs_dir *fd, uint32_t flags)
{
	(void)fd;
	AW_FILE *fp;
	if(flags & AWF_WR)
		return NULL; // We don't support writing yet
	
	if(!(flags & (AWF_RD|AWF_WR)))
		return NULL; // Invalid access mode
	
	fp = malloc(sizeof(AW_FILE));
	
	if(!fp)
		return NULL; // TODO: set errno to ENOMEM
	
	fp->flags = flags;
	
	fp->def = &ramfs_def;
	fp->clus = fp->fposl = fp->fposh = fp->clus_pos = 0;
	fp->clus_count = fp->flenl = fp->flenh = 0xFFFFFFFF;
	fp->clus_len = 0; // TODO: actually get this working
	
	return fp;
};

struct fs_dir *ramfs_fs_getdir(struct fs_dir *dd)
{
	(void)dd;
	return NULL;
};
struct fs_dir *ramfs_fs_getfirstent(struct fs_dir *dd)
{
	(void)dd;
	return NULL;
};
struct fs_dir *ramfs_fs_getprevent(struct fs_dir *dd)
{
	(void)dd;
	return NULL;
};
struct fs_dir *ramfs_fs_getnextent(struct fs_dir *dd)
{
	(void)dd;
	return NULL;
};
