/***************************************************************
 *
 * fault/assert.c
 * assertion-fail routine for AWOS
 *
 * See LICENSE file included with this source for copyright
 * information.
 *
 ***************************************************************/

#include <kernel.h>

void __assert_fail(const char *cond, const char *file, int line, const char *func)
{
	printf("Kernel-level assertion failed.\n");
	dprintf("*** ASSERTION FAILED: \"%s\" in %s\nFile %s on line %i\n", cond, func, file, line);
	panic("Assertion failed.");
	/* death */
}
