/***************************************************************
 *
 * fault/fixme.c
 * __fixme() and __fixmed() for AWOS
 *
 * See LICENSE file included with this source for copyright
 * information.
 * 
 ***************************************************************/

#include <kernel.h>	/* printf(), dprintf() */
#include <fixme.h>

/*! \fn void __fixme(const char *fnname)
 * \brief Prints onscreen that this function needs to be written
 * \param fnname Name of function that needs to be fixed
 * \return Nothing
 */
void __fixme(const char *fnname)
{
	printf("A program called '%s', which is not currently implemented.\n", fnname);
	return;
}

/*! \fn void __fixmed(const char *fnname, const char *file, int line)
 * \brief Prints onscreen that this function needs to be fixed
 * \param fnname Name of funciton that needs to be fixed
 * \param file File containing function in need of fixing
 * \param line Line number
 * \return Nothing
 */
void __fixmed(const char *fnname, const char *file, int line)
{
	dprintf("fixme: the function '%s' needs fixing (file %s, line %i)\n", fnname, file, line);
	return;
}

