/****************************************************************
 *
 * kernel/mutex.c
 * mutex functions for AWOS Kernel
 * 
 * See LICENSE file included with this source for copyright
 * information.
 * 
 ****************************************************************/

#include <stdint.h>
#include <portio.h>
#include <mutex.h>

extern void cli();
extern void sti();

static BOOL mutexes[MAX_MUTEX];

BOOL MxGetMutex(uint32_t type)
{
	if(MxIsMutexed(type)) return FALSE;
	mutexes[type] = TRUE;
	return TRUE;
};

BOOL MxIsMutexed(uint32_t type)
{
	int i;
	cli();
	i = mutexes[type];
	sti();
	return i;
};

void MxReleaseMutex(uint32_t type)
{
	mutexes[type] = FALSE;
	return;
};

