/***************************************************************
 *
 * net/hal/iface-mgr.h
 * Interface Manager defines for ADM-compatible NIC drivers
 *
 * See LICENSE file included with this source for copyright
 * information.
 *
 ***************************************************************/

#include "hal_driver.h"

#ifndef __AWOS_NET_HAL_IFACE_MGR_H_
#define __AWOS_NET_HAL_IFACE_MGR_H_

// These functions MUST be accessible by our C friends.
extern "C"
{
	extern void *kmalloc(size_t);
	extern void *krealloc(void *, size_t);
	void NetHalInterfaceStart(void);
	int NetHalInterfaceAdd(Net_IfaceDriver *);
	Net_IfaceDriver *NetHalGetInterface(uint32_t);
	void __NetHalRealloc(void);
}

#endif /* !__AWOS_NET_HAL_IFACE_MGR_H_ */

