#include "../hal/hal_driver.h"

extern "C"
{
#include <pci.h>
}

class Net_NE2000IfDrv : public Net_IfaceDriver
{
public:
	Net_NE2000IfDrv();
	~Net_NE2000IfDrv();

	BOOL InitializeDriver();
	BOOL IsDriverInUse();
	BOOL DisposeDriver();

	int PushData(int, void *);
	int RetrData(int, void *);

	uint32_t GetDeviceFlags();
	BOOL IsFlagSet(uint32_t);
	BOOL SetDeviceFlag(uint32_t);
private:
	//uint32_t GetDeviceStatus();
	
	struct pcidev_ll *pciDevice;
	
	static const int DEVS_SUPP = 9;
	
	struct {
		uint16_t vendor;
		uint16_t product;
	} pciDevicesSupported[DEVS_SUPP];
	
	void SetRegisterPage(unsigned int);
	
	//uint32_t *mem_start;
};

